stages:
  - build
  - test
  - deploy

variables:
  BUILD_DIRECTORY: "6.0"
  DEPLOY_TAG: "6.0"
  CI_APPLICATION_REPOSITORY: "$CI_REGISTRY_IMAGE/build"
  CI_APPLICATION_TAG: "build-$CI_COMMIT_SHA-6.0"

.build: &build
  image: docker:latest
  stage: build
  services:
    - docker:dind
  before_script:
    - cat /etc/os-release
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - env
    - cd "$CI_PROJECT_DIR/$BUILD_DIRECTORY"
    - docker build --tag "$CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG" .
    - docker push "$CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG"

.deploy: &deploy
  image: docker:latest
  stage: deploy
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker pull "$CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG"
    - docker tag "$CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG" "$CI_REGISTRY_IMAGE:$DEPLOY_TAG"
    - docker push "$CI_REGISTRY_IMAGE:$DEPLOY_TAG"
  rules:
    - if: '$CI_COMMIT_TAG'
      when: on_success

build-6.0:
  <<: *build
  variables:
    BUILD_DIRECTORY: "6.0"
    DEPLOY_TAG: "6.0"
    CI_APPLICATION_REPOSITORY: "$CI_REGISTRY_IMAGE/build"
    CI_APPLICATION_TAG: "build-$CI_COMMIT_SHA-6.0"

deploy-6.0:
  <<: *deploy
  variables:
    BUILD_DIRECTORY: "6.0"
    DEPLOY_TAG: "6.0"
    CI_APPLICATION_REPOSITORY: "$CI_REGISTRY_IMAGE/build"
    CI_APPLICATION_TAG: "build-$CI_COMMIT_SHA-6.0"


include:
  - template: Container-Scanning.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: SAST.gitlab-ci.yml
  - template: Code-Quality.gitlab-ci.yml
